import 'dart:ui';

import 'package:flutter/material.dart';
import 'package:flutter/rendering.dart';
import 'package:widget2image/widget2image.dart';

void main() => runApp(MyApp());

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
        title: 'Flutter Demo',
        theme: ThemeData(
          primarySwatch: Colors.blue,
        ),
        home: Scaffold(
          appBar: AppBar(),
          body: HomePage(),
        ));
  }
}

class HomePage extends StatefulWidget {
  @override
  _HomePageState createState() => _HomePageState();
}

class _HomePageState extends State<HomePage> {
  @override
  Widget build(BuildContext context) {
    return Widget2Image(
      format: ImageByteFormat.png,
      child: Container(
        alignment: Alignment.center,
        height: 200,
        width: 200,
        color: Colors.red,
        child: Builder(
          builder: (ctx) => IconButton(
            icon: Icon(Icons.ac_unit),
            onPressed: () => _loadImage(ctx),
          ),
        ),
      ),
    );
  }

  _loadImage(BuildContext context) async {
    var bytes = await Widget2Image.of(context).loadImage();
    print(bytes);
    // 获取到图片字节数据 ---- 之后可随意操作
//    final dir = await getTemporaryDirectory();
//    final dest = path.join(dir.path, "widget.png");
//    await File(dest).writeAsBytes(bytes);
//    Scaffold.of(context).showSnackBar(SnackBar(content: Text("图片已保存到:$dest")));
  }
}
